/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/*  functions are:
 *       sortNam()
 *       sortIx()
 *       sortChron()
 *       sortComp()
 *       comparIx()
 *       comparChron()
 *       comparComp()
 *       comparNam()    *** moved to Stuff/
 */
#include "pedchk.h"

void sortNam (void)
{
   qsort (ppKeyTab, nInd, sizeof (KEYS_PTRS), comparNam);

   return;
}
void sortIx (void)
{
   qsort (ppKeyTab, nInd, sizeof (KEYS_PTRS), comparIx);

   return;
}
void sortChron (void)
{
   qsort (ppKeyTab, nInd, sizeof (KEYS_PTRS), comparChron);

   return;
}
void sortComp (void)
{
   qsort (ppKeyTab, nInd, sizeof (KEYS_PTRS), comparComp);

   return;
}

#if 0
int comparNam (const void *p1, const void *p2) /* *** moved to stuff  ***  */
{
/* KEYS_PP ppK1 = * (KEYS_PTRS * const *)p1;
   KEYS_PP ppK2 = * (KEYS_PTRS * const *)p2;
 */
   KEYS_PP ppK1;
   KEYS_PP ppK2;
   int   result;

   ppK1 = (KEYS_PP const) p1;
   ppK2 = (KEYS_PP const) p2;

   result = strncmp ((*ppK1)->nam, (*ppK2)->nam, MAXNAMLEN);
   if (result < 0)
      return -1;
   else if (result == 0)
      return 0;
   else
      return 1;
}
#endif
int comparIx (const void *p1, const void *p2)
{
   KEYS_PP ppK1;
   KEYS_PP ppK2;

   ppK1 = (KEYS_PP const) p1;
   ppK2 = (KEYS_PP const) p2;

   if ((*ppK1)->ix < (*ppK2)->ix)
      return -1;
   else if ((*ppK1)->ix == (*ppK2)->ix)
      return 0;
   else
      return 1;
}
int comparChron (const void *p1, const void *p2)
{
   KEYS_PP ppK1;
   KEYS_PP ppK2;

   ppK1 = (KEYS_PP const) p1;
   ppK2 = (KEYS_PP const) p2;

   if ((*ppK1)->chron < (*ppK2)->chron)
      return -1;
   else if ((*ppK1)->chron == (*ppK2)->chron)
      return 0;
   else
      return 1;
}
int comparComp (const void *p1, const void *p2)
{
   KEYS_PP ppK1;
   KEYS_PP ppK2;

   ppK1 = (KEYS_PP const) p1;
   ppK2 = (KEYS_PP const) p2;

   if ((*ppK1)->comp < (*ppK2)->comp)
      return -1;
   else if ((*ppK1)->comp > (*ppK2)->comp)
      return 1;
   else if ((*ppK1)->chron < (*ppK2)->chron)
      return -1;
   else if ((*ppK1)->chron == (*ppK2)->chron)
      return 0;
   else
      return 1;
}
